﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Sample145862;
using MVCSampleBrowser.Models;
using Syncfusion.Linq;
using System.Collections;
using Syncfusion.JavaScript;

using System.Web.Script.Serialization;
using System.Net;
using System.Reflection;
using System.EnterpriseServices;

using System.ComponentModel;
using Syncfusion.JavaScript.DataSources;
namespace Sample145862.Controllers
{
    public class GridController : Controller
    {
        //
        // GET: /Grid/
       // List<ParentItem> parent = new List<ParentItem>();
        public static List<Orders> order = new List<Orders>();

        public List<Orders> BindDataSource()
        {
            int orderId = 10000;
            int empId = 0;
            for (int i = 1; i < 101; i++)
            {
                order.Add(new Orders(orderId + 1, empId + 1, "VINET", "Reims", new DateTime(1991, 05, 15),true));
                order.Add(new Orders(orderId + 2, empId + 2, "VICTE", "Munster", new DateTime(1990, 04, 04),false));
                order.Add(new Orders(orderId + 3, empId + 2, "VINET", "Berlin", new DateTime(1957, 11, 30),true));
                order.Add(new Orders(orderId + 4, empId + 4, "VICTE", "Mexico", new DateTime(1930, 10, 22),true));
                order.Add(new Orders(orderId + 5, empId + 4, "FRGYE", "Colchester", new DateTime(1953, 02, 18),false));
                order.Add(new Orders(orderId + 6, empId + 6, "HANAR", "Lyon", new DateTime(1995, 10, 22),true));
                order.Add(new Orders(orderId + 7, empId + 7, "RICSU", "Bern", new DateTime(1999, 05, 29),false));
                order.Add(new Orders(orderId + 8, empId + 8, "WELLI", "Graz", new DateTime(2000, 01, 01),true));
                order.Add(new Orders(orderId + 9, empId + 9, "ERNSH", "Seattle", new DateTime(1996, 08, 08),true));
                order.Add(new Orders(orderId + 10, empId + 10, "CENTC", "Oulu", new DateTime(2005, 03, 15),true));
                orderId += 10;
                empId += 10;

            }

            return order;
        }

       
        public class Orders
        {
            public Orders()
            {

            }
            public Orders(long OrderID, int EmployeeID, string CustomerId, string ShipCity, DateTime OrderDate, bool Verified)
            {
                this.OrderID = OrderID;
                this.EmployeeID = EmployeeID;
                this.CustomerID = CustomerId;
                this.ShipCity = ShipCity;
                this.OrderDate = OrderDate;
                this.Verified = Verified;
            }
            public long OrderID { get; set; }
            public int EmployeeID { get; set; }
            public string CustomerID { get; set; }
            public string ShipCity { get; set; }
            public DateTime OrderDate { get; set; }

            public bool Verified { get; set; }

        }
        public ActionResult GridFeatures()
        {
            BindDataSource();
            var DataSource = order.ToList();
            ViewBag.datasource = DataSource;
            var DataSource2 = new NorthwindDataContext().EmployeeViews.ToList();
            ViewBag.dataSource2 = DataSource2;
           // var DataSource3 = new NorthwindDataContext().ToList();
           // ViewBag.dataSource3 = DataSource3;
            return View();
        }
        public ActionResult UrlDataSource(DataManager dm)
        {

            IEnumerable DataSource = order.ToList();
            DataOperations ds = new DataOperations();
            List<string> str = new List<string>();
            if (dm.Search != null && dm.Search.Count > 0)
            {
                DataSource = ds.PerformSearching(DataSource, dm.Search);
            }
            if (dm.Sorted != null && dm.Sorted.Count > 0) //Sorting
            {
                DataSource = ds.PerformSorting(DataSource, dm.Sorted);
            }
            if (dm.Where != null && dm.Where.Count > 0) //Filtering
            {
                DataSource = ds.PerformWhereFilter(DataSource, dm.Where, dm.Where[0].Operator);
            }
            if (dm.Aggregates != null)
            {
                for (var i = 0; i < dm.Aggregates.Count; i++)
                    str.Add(dm.Aggregates[i].Field);

            }
            IEnumerable aggregate = ds.PerformSelect(DataSource, str);
            var count = DataSource.Cast<Orders>().Count();
            DataSource = ds.PerformSkip(DataSource, dm.Skip);
            DataSource = ds.PerformTake(DataSource, dm.Take);
            return Json(new { result = DataSource, count = count, aggregate = aggregate });
        }
        public List<object> Name
        {
            get
            {
                var Employee = new NorthwindDataContext().EmployeeViews.Select(x => x.FirstName).Distinct().ToList();
                var Emp_name = new List<object>();
                foreach (var name in Employee)
                {
                    Emp_name.Add(new { value = name, text = name });
                }
                return Emp_name;
            }
        }

        //public ActionResult Update(Orders value)
        //{
        //    var ds = new NorthwindDataContext();
        //    var query = from ord in ds.Orders where ord.OrderID == value.OrderID select ord;
        //    foreach (Orders in query)
        //    {
        //        ord.OrderID = value.OrderID;
        //        ord.EmployeeID = value.EmployeeID;
        //        ord.ShipCity = value.ShipCity;
        //        ord.ShipName = value.ShipName;
        //        ord.Freight = value.Freight;
        //    }
        //    ds.SubmitChanges();
        //    return Json(value, JsonRequestBehavior.AllowGet);
        //}
        //public ActionResult Insert(OrdersView value)
        //{
        //    var ds = new NorthwindDataContext();


        //    ds.OrdersViews.InsertOnSubmit(value);
        //    ds.SubmitChanges();

        //    var jsonData =  OrderRepository.GetAllRecords();

        //    return Json(jsonData, JsonRequestBehavior.AllowGet);
        //    //OrderRepository.GetEditable(value);
        //    //var data = OrderRepository.GetAllRecords();
        //    //return Json(data, JsonRequestBehavior.AllowGet);
        //}
        //public int Data(int value)
        //{
        //   // Do some stuff here
        //    return value;

        //}

        //public ActionResult Delete(int key)
        //{
        //    var ds = new NorthwindDataContext();
        //    var query = from ord in ds.OrdersViews where ord.OrderID == key select ord;

        //    foreach (OrdersView detail in query)
        //        ds.OrdersViews.DeleteOnSubmit(detail);
        //    ds.SubmitChanges();
        //    return Json(key, JsonRequestBehavior.AllowGet);
        //}
        
        public ActionResult Update(Orders value)
        {
            
            Orders val = order.Where(or => or.OrderID == value.OrderID).FirstOrDefault();
            val.OrderID = value.OrderID;
            val.EmployeeID = value.EmployeeID;
            val.CustomerID = value.CustomerID;
            val.ShipCity = value.ShipCity;
            return Json(value);
        }
        public ActionResult Insert(Orders value)
        {
            order.Insert(order.Count, value);
            return Json(order);
        }
        public ActionResult Delete(int key)
        {
            order.Remove(order.Where(or => or.OrderID == int.Parse(key.ToString())).FirstOrDefault());
            return Json(key);
        }
        public class DataResult
        {
            public IEnumerable<OrdersView> result { get; set; }
            public int count { get; set; }
        }
     }
}
